package bfv.hardware;

import bfv.desktop.BFVDesktop;
//import jssc.SerialPortList;

import javax.swing.*;
import javax.swing.border.TitledBorder;
import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.ArrayList;

/**
 * Created by FlyingAl on 15/03/14.
 */
public class HardwareSettingPanel extends JPanel{



    private HardwareParameters hardwareParameters;
    private HardwareCommands hardwareCommands;
    private BFVDesktop desktop;




    public HardwareSettingPanel(BFVDesktop desktop) {

        this.desktop = desktop;
        hardwareParameters = new HardwareParameters(desktop);
        hardwareCommands = new HardwareCommands(desktop);

        this.setLayout(new BoxLayout(this, BoxLayout.Y_AXIS));
        this.setBorder(new TitledBorder("Hardware Parameters"));








        JPanel scrollPanel = new JPanel();
        scrollPanel.setLayout(new BoxLayout(scrollPanel, BoxLayout.Y_AXIS));

        JScrollPane scroll = new JScrollPane(scrollPanel);
        scroll.setPreferredSize(new Dimension(300,400));
        this.add(scroll);

        ArrayList<HardwareParameter> parameters = hardwareParameters.getParameters();

        for (int i = 0; i < parameters.size(); i++) {
            HardwareParameter hardwareParameter =  parameters.get(i);
            HardwareSettingField field = new HardwareSettingField(hardwareParameter);
            field.setAlignmentX(0.0f);
            scrollPanel.add(field);




        }



    }

    public HardwareParameters getHardwareParameters() {
        return hardwareParameters;
    }

    public void updateHardwareVersion(){

        ArrayList<HardwareParameter> parameters = hardwareParameters.getParameters();


    }

    public HardwareCommands getHardwareCommands() {
        return hardwareCommands;
    }
}


